// Laurent Doucet, Erg, June 06 
// http://www.workplace.lescorsaires.be/spritek/
// built with Processing 123 Beta

float x1speed; float x2speed; float x3speed;
float y1speed; float y2speed; float y3speed;
int x1; int x2; int x3;
int y1; int y2; int y3;
int r = 10;

void setup() {
  size(300,300);
  frameRate(40);
  smooth();
  
  x1 = width/2;
  x1speed = random(-2,-1);
  y1 = height/2;
  y1speed = random(1,2);
  x2 = width/2;
  x2speed = random(1,2);
  y2 = height/2;
  y2speed = random(2,4);
  x3 = width/2;
  x3speed = random(1,3);
  y3 = height/2;
  y3speed = random(-3,-1);
}

void draw() {
  background(0);
  ellipseMode(CENTER);
  noStroke();
  fill(255);
  ellipse(x1,y1,r,r);
 
  x1 += x1speed;
  y1 += y1speed;
 
  if ((x1 > width) || (x1 < 0)) {
   x1speed = x1speed*-1;
 }
  if ((y1 > height) || (y1 < 0)) {
   y1speed = y1speed*-1;
 }

  fill(255);
  ellipse(x2,y2,r,r);
 
  x2 += x2speed;
  y2 += y2speed;
 
  if ((x2 > width) || (x2 < 0)) {
   x2speed = x2speed*-1;
 }
  if ((y2 > height) || (y2 < 0)) {
   y2speed = y2speed*-1;
 }
  fill(255);
  ellipse(x3,y3,r,r);
 
  x3 += x3speed;
  y3 += y3speed;
 
  if ((x3 > width) || (x3 < 0)) {
   x3speed = x3speed*-1;
 }
  if ((y3 > height) || (y3 < 0)) {
   y3speed = y3speed*-1;
 }
 
  if ((((dist(x1,y1,x2,y2)) < 200) && ((dist(x1,y1,x3,y3)) < 200)) && ((dist(x2,y2,x3,y3)) < 200)) {
   stroke (0,255,0);
   noFill();
   bezier(x1,y1,(x1+25),(y1+25),(x2+25),(y2+25),x2,y2);
   bezier(x1,y1,(x1+25),(y1+25),(x3+25),(y3+25),x3,y3);
   bezier(x2,y2,(x2+25),(y2+25),(x3+25),(y3+25),x3,y3);
 }
  if ((((dist(x1,y1,x2,y2)) < 200) && ((dist(x1,y1,x3,y3)) < 200)) && ((dist(x2,y2,x3,y3)) > 200)) {
   stroke (255,0,0);
   noFill();
   bezier(x1,y1,(x1+25), (y1+25), (x2+25), (y2+25) ,x2,y2);
   bezier(x2,y2,(x2+25), (y2+25), (x3+25), (y3+25) ,x3,y3);
 }
  if ((((dist(x1,y1,x2,y2)) < 200) && ((dist(x1,y1,x3,y3)) > 200)) && ((dist(x2,y2,x3,y3)) < 200)) {
   stroke (255,0,0);
   noFill();
   bezier(x1,y1,(x1+25), (y1+25), (x2+25), (y2+25) ,x2,y2);
   bezier(x2,y2,(x2+25), (y2+25), (x3+25), (y3+25) ,x3,y3);
 }
  if ((((dist(x1,y1,x2,y2)) > 200) && ((dist(x1,y1,x3,y3)) < 200)) && ((dist(x2,y2,x3,y3)) < 200)) {
   stroke (255,0,0);
   noFill();
   bezier(x1,y1,(x1+25), (y1+25), (x3+25), (y3+55) ,x3,y3);
   bezier(x2,y2,(x2+25), (y2+25), (x3+25), (y3+55) ,x3,y3);
 }
  if ((((dist(x1,y1,x2,y2)) < 200) && ((dist(x1,y1,x3,y3)) > 200)) && ((dist(x2,y2,x3,y3)) > 200)) {
   stroke (255,255,0);
   noFill();
   bezier(x1,y1,(x1+25), (y1+25), (x2+25), (y2+25) ,x2,y2);
 }
  if ((((dist(x1,y1,x2,y2)) > 200) && ((dist(x1,y1,x3,y3)) < 200)) && ((dist(x2,y2,x3,y3)) > 200)) {
   stroke (255,255,0);
   noFill();
   bezier(x1,y1,(x1+25), (y1+25), (x3+25), (y3+25) ,x3,y3);
 }
  if ((((dist(x1,y1,x2,y2)) > 200) && ((dist(x1,y1,x3,y3)) > 200)) && ((dist(x2,y2,x3,y3)) < 200)) {
   stroke (255,255,0);
   noFill();
   bezier(x2,y2,(x2+25), (y2+25), (x3+25), (y3+25) ,x3,y3);
 }  
}
